import os, sys, time
import unittest
from sets import Set
import traceback

if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase

from Products.CMFCore.utils import getToolByName
from Products.filter import api as fapi
from Products.wicked import utils
from Products.wicked.lib.filter import WickedFilter
from wickedtestcase import WickedTestCase

class TestWickedFilter(WickedTestCase):
    wicked_type = 'IronicWiki'
    wicked_field = 'body'

    def afterSetUp(self):
        """
        sets the body of page1 to be a wicked link of the id of page2
        """
        WickedTestCase.afterSetUp(self)
        field = self.page1.getField(self.wicked_field)
        field.getMutator(self.page1)("((%s))" % self.page2.getId())
        self.filter = utils.getFilter(self.page1)

    def test_getLinkTargetBrain(self):
        brain = self.filter.getLinkTargetBrain(self.page2.getId())
        self.failUnless(brain.getObject()) == self.page2

    def test_renderLinkForBrain(self):
        cat = getToolByName(self.portal, 'portal_catalog')
        brain = cat(id=self.page2.getId())[0]
        field = self.page1.getField(self.wicked_field)

        rendered = self.filter.renderLinkForBrain(field.template,
                                                      field.wicked_macro,
                                                      brain.id,
                                                      brain)
        self.failUnless(rendered in field.getAccessor(self.page1)())


def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(TestWickedFilter))
    return suite

if __name__ == '__main__':
    framework()
